/* 940202 P1_DiMP.C */

#include "stdarg.h"
#include "stdio.h"
#include "ctype.h"
#include "string.h"
#include "alloc.h"
#include "p1_common.h"
#include "p1_parser.h"
#include "p1_scanner.h"
#include "stdio.h"

#define IO_SIZE_BIN     8   /* The number of bits needed to make an */
#define IO_SIZE_HEX    16   /* 8 char or 32 bit output               */
#define IO_SIZE_OCT    15   /* must be less than host word size */
#define IO_SIZE_CHAR   16   /* 4 char per 32 bits */
#define IO_SIZE_LOGICAL 8
#define IO_SIZE_CARD   16
#define IO_SIZE_INT    16
#define IO_SIZE_LONGINT 16
#define IO_SIZE_REAL   16   /* must be less than host word size */

char *off_exp1();
char *off_exp2();
char *off_exp3();
char *off_exp4();
char *off_exp5();
char *off_exp6();

/*  This routine parses statements of the form:

input {(rbuf)} a[$], b[$], c[$] in logical expression 1
     {using logical parallel varible} ;
also

input scalar scalar scalar

It causes the specified fields of all allocated cells of logical expression 1
   to be printed in tabular form in logical expression 2 order if present.

*/

int dimp_()
{ 
	/* local variables */
	int return_value=0,as_index=0,cnt=0,sc_temp_dx=0;
	int buf_index=0,sc_count_dx=0,id_index=0,id_offset, xx_get_dx, xx_temp_dx;
	int as_offset, lx_offset, lx_temp_dx, lx_value;
	int bufsz_dx, sc_cnt_dx, string_dx;
	int j,a_words,a_width,bit_dx,out_bits;
	char c_idsize[10];
	char *loop_label, *exit_label, *gexit_label;
	int aux_cnt;
	int code, mode, log_dx, log_off;
	int save_id_offset, bi_index, lx_index, lex_bi;
	int int_off;
	int obuf_index,obuf_offset;
	int first;
	int alloc_num_dx;

	/* initialize local variables */
	return_value = 0;
	as_index = 0;
	cnt = 0;
	sc_temp_dx = 0;
	buf_index = 0;
	sc_count_dx = 0;
	id_index = 0;
	id_offset = 0;
	xx_get_dx = 0;
	xx_temp_dx = 0;
	as_offset = 0;
	lx_offset = 0;
	lx_temp_dx = 0;
	lx_value = 0;
	bufsz_dx, sc_cnt_dx, string_dx;
	j = 0;
	a_words = 0;
	a_width = 0;
	bit_dx = 0;
	out_bits = 0;

	strcpy( c_idsize, "" );
	loop_label = NULL;
	exit_label = NULL;
	gexit_label = NULL;

	aux_cnt = 0;
	code = 0;
	mode = 0;
	log_dx = 0;
	log_off = 0;
	save_id_offset = 0;
	bi_index = 0;
	lx_index = 0;
	lex_bi = 0;
	int_off = 0;
	obuf_index = 0;
	obuf_offset = 0;
	first = 0;
	alloc_num_dx = 0;




  if(debug == 2) printf("In dimp() ...\n");

  as_index = SUCCESS;  /* added 020803 */
  return_value=SUCCESS;
  buf_index = SC_IO_BUFFER;
  loop_label=make_label("RD$S",++loop_count);
  exit_label=make_label("RD$E",loop_count);
  gexit_label=make_label("RD$G",loop_count);

  sc_count_dx = get_symtab_temp(T_INT,T_SCALAR,W_INT);

  obuf_index = sysin_dx; obuf_offset = SUCCESS;
  if((token_type = get_token()) == T_LPAR)
    {token_type = get_token();
     if(element(&obuf_index,&obuf_offset) != FAIL)
	if(token_type == T_RPAR)
	   token_type = get_token();
	else rwbuf_err();
     else rwbuf_err(); }

   /* parse list */
/*   if((aux_cnt=list_parse()) == FAIL) return(FAIL); */
   aux_cnt=list_parse();
/* if no T_IN, assumed to be scalar input */
  if(aux_cnt != FAIL)
 {if (token_type == T_IN)
     {code = T_COREAD; token_type = get_token();}
  as_index=symtab_fetch(token_size,token_buf); /* association name */
  token_type=get_token(); /* consume [ */
  subscript(as_index,&log_dx,&log_off);
  as_index = log_dx;
  as_offset = log_off;

  if(token_type == T_USING) /* lexicon option */
    {mode = T_LEX; token_type = get_token();
     lx_index=symtab_fetch(token_size,token_buf); /* lexicon name */
     token_type=get_token(); /* consume [ */
     subscript(lx_index,&log_dx,&log_off);
     lx_index = log_dx;
     lx_offset = log_off;
     lx_index = symtab_fetch(4,"LEX$");
     lx_offset = SUCCESS;
     lex_bi = symtab_fetch(7,"LEX_BI$");
     lx_value = symtab_fetch(8,"LEX_VAL$");
    }

  if(token_type != T_EOS) print_msg(EOS_ERR,token_buf);
    else token_type = get_token();
  if (as_index == FAIL) return_value = FAIL;

   if (symbol_table[as_index].mode1 != T_LOGICAL &&
	    symbol_table[as_index].mode2 != T_PARALLEL)
     {print_msg (LOGEXP_ERR, token_buf);
      return FAIL;}

   xx_get_dx = get_symtab_temp(T_LOGICAL,T_PARALLEL,W_LOGICAL);
   xx_temp_dx = get_symtab_temp(T_LOGICAL,T_PARALLEL,W_LOGICAL);
   lx_temp_dx = get_symtab_temp(T_LOGICAL,T_PARALLEL,W_LOGICAL);
   bi_index = as_index;
   sc_temp_dx = get_symtab_temp(T_INT,T_SCALAR,W_INT);
   sc_cnt_dx = get_const("0",T_DEC_CONST);
/* T_LOOP */
   print_opcode("loop_",T_LOOP,T_NONE,T_NONE);
   print_args(loop_label,NULL,NULL,NULL,NULL);
/* read line */
   print_opcode("read_nl_",T_READLN, T_NONE, T_NONE);
   print_args(off_exp1(obuf_index, obuf_offset),
	      off_exp2(sc_temp_dx,SUCCESS),gexit_label,NULL,NULL);
   print_opcode("until_",T_UNTIL,T_NONE,T_SCALAR);
   print_args(off_exp1(sc_temp_dx,SUCCESS),exit_label,NULL,NULL,NULL);
/* set mode to T_REREAD, T_COREAD or T_READ */
  alloc_num_dx = get_const("1",T_DEC_CONST);
  print_opcode("alloc_",T_ALLOCATE,T_NONE,T_ALLDIMP);
  print_args(off_exp1(xx_temp_dx,SUCCESS),
	     off_exp2(bi_index,SUCCESS),
	     off_exp3(alloc_num_dx,SUCCESS), NULL, NULL);
   list_pt =0;
   cnt=0;
   first = TRUE;
   while((id_index=next_elem()) != FAIL)
     {/* two entries per field */
      if((id_offset = next_elem()) == FAIL) id_offset=SUCCESS;
      a_words = msg_aux_words(id_index,&a_width);
      out_bits = a_width;
      bit_dx = SUCCESS;
      save_id_offset = id_offset;
      if(code_type == EMULATE) int_off=0;
      /* in dump, 32 bit reals and long integers should generate only one entry */
      if(a_width == 16 && (symbol_table[as_index].mode1 == T_REAL ||
			   symbol_table[as_index].mode1 == T_LONGINT )) a_words--;
      for(j=0; j<= a_words; j++) /* iterate for every column of output */
	{sc_temp_dx = get_symtab_temp(T_LONGINT,T_SCALAR,
				      symbol_table[id_index].width);
	 pc_itoa(symbol_table[id_index].width,c_idsize);
	 bufsz_dx = get_const(c_idsize,T_DEC_CONST);
	 print_opcode("dimp_",T_DIMP,symbol_table[id_index].mode1,
				     symbol_table[id_index].mode2);
	 print_args(off_exp1(sc_temp_dx,SUCCESS),c_idsize,NULL,NULL,NULL);
	 print_opcode("mvsc_",T_MVSC,symbol_table[id_index].mode1,T_MASKEDMOVE);
	 print_args(off_exp1(xx_temp_dx,SUCCESS),
		    off_exp2(sc_temp_dx,SUCCESS),
		    off_exp3(id_index,id_offset),
		    NULL, NULL);

  if((unsigned) mode == (unsigned) T_LEX)
    {print_opcode("alloc_",T_ALLOCATE,T_NONE,T_ALLDIMP);
     print_args(off_exp1(lx_temp_dx,SUCCESS),
	     off_exp2(lex_bi,SUCCESS),
	     off_exp3(alloc_num_dx,SUCCESS), NULL, NULL);}
  if((unsigned) mode == (unsigned) T_LEX)
	   {print_opcode("lex_",T_LEX,symbol_table[id_index].mode1,T_MASKEDMOVE);
	    print_args(off_exp1(lx_temp_dx,SUCCESS),
		    off_exp2(sc_temp_dx,SUCCESS),
		    off_exp3(lx_index,lx_offset),
		    NULL, NULL);
	    string_dx = get_const(symbol_table[id_index].tokpts,T_STRING);
	    print_opcode("mvsc_",T_MVSC,T_CHAR,T_MASKEDMOVE);
	    print_args(off_exp1(lx_temp_dx,SUCCESS),
		       off_exp2(string_dx,SUCCESS),
		       off_exp3(lx_value,lx_offset),
		       NULL, NULL);
	  }
     }
  }
/* T_ENDLOOP */
   print_opcode("endloop",T_ENDLOOP,T_NONE,T_NONE);
   print_args(exit_label,loop_label,NULL,NULL,NULL);
}
else
{if(token_type != T_EOS)
    return(FAIL);
  if (as_index == FAIL) return_value = FAIL;
  token_type = get_token();
   sc_temp_dx = get_symtab_temp(T_INT,T_SCALAR,W_INT);
   print_opcode("read_nl_",T_READLN, T_NONE, T_NONE);
   print_args(off_exp1(obuf_index, obuf_offset),
	      off_exp2(sc_temp_dx,SUCCESS),gexit_label,NULL,NULL);
 /* scalar input mode */
   list_pt =0;
   cnt=0;
   first = TRUE;
   while((id_index=next_elem()) != FAIL)
     {/* two entries per field */
      if((id_offset = next_elem()) == FAIL) id_offset=SUCCESS;
      a_words = msg_aux_words(id_index,&a_width);
      out_bits = a_width;
      bit_dx = SUCCESS;
      save_id_offset = id_offset;
      if(code_type == EMULATE) int_off=0;
      /* in dump, 32 bit reals and long integers should generate only one entry */
      if(a_width == 16 && (symbol_table[as_index].mode1 == T_REAL ||
			   symbol_table[as_index].mode1 == T_LONGINT )) a_words--;
      for(j=0; j<= a_words; j++) /* iterate for multiple scalar input variable */
				 /* i.e. greater than 16 bits - not fully implemented */
	{pc_itoa(symbol_table[id_index].width,c_idsize);
	 bufsz_dx = get_const(c_idsize,T_DEC_CONST);
	 print_opcode("dimp_",T_DIMP,symbol_table[id_index].mode1,
				     symbol_table[id_index].mode2);
	 print_args(off_exp1(id_index,id_offset),c_idsize,NULL,NULL,NULL);
	}
    }
}
   return(return_value);
}

