/* 940113 P1_DUMP.C */

#include "stdarg.h"
#include "stdio.h"
#include "ctype.h"
#include "string.h"
#include "alloc.h"
#include "p1_common.h"
#include "p1_parser.h"
#include "p1_scanner.h"
#include "stdio.h"

#define IO_SIZE_BIN     8   /* The number of bits needed to make an */
#define IO_SIZE_HEX    16   /* 8 char or 32 bit output               */
#define IO_SIZE_OCT    15   /* must be less than host word size */
#define IO_SIZE_CHAR   16   /* 4 char per 32 bits */
#define IO_SIZE_LOGICAL 8
#define IO_SIZE_CARD   16
#define IO_SIZE_INT    16
#define IO_SIZE_LONGINT 16
#define IO_SIZE_REAL   16   /* must be less than host word size */

char *off_exp1();
char *off_exp2();
char *off_exp3();
char *off_exp4();
char *off_exp5();
char *off_exp6();

/*  This routine parses statements of the form:

dump {(rbuf)} a[$], b[$], c[$] in logical expression 1
     {sorted by logical expression 2} ;

It causes the specified fields of all allocated cells of logical expression 1
   to be printed in tabular form in logical expression 2 order if present.

*/

int dump_()
{ int return_value,as_index,cnt,sc_temp_dx;
  int buf_index,sc_count_dx,id_index,id_offset, xx_get_dx, xx_temp_dx;
  int xx_min_dx;
  int as_offset;
  int bufsz_dx;
  int j,a_words,a_width,bit_dx,out_bits;
  char c_idsize[10];
  char *loop_label, *exit_label, *gexit_label;
  int aux_cnt;
  int save_id_offset;
  int int_off;
  int obuf_index,obuf_offset;
  int sort_dx, slog_dx, slog_off;

  if(debug == 2) printf("In dump() ...\n");

  as_index = SUCCESS;  /* modified 020803 */
  return_value=SUCCESS;
  buf_index = SC_IO_BUFFER;
  loop_label=make_label("PT$S",++loop_count);
  exit_label=make_label("PT$E",loop_count);
  gexit_label=make_label("PT$G",loop_count);

  sc_count_dx = get_symtab_temp(T_INT,T_SCALAR,W_INT);

  obuf_index = sysot_dx; obuf_offset = SUCCESS;
  if((token_type = get_token()) == T_LPAR)
    {token_type = get_token();
     if(element(&obuf_index,&obuf_offset) != FAIL)
	if(token_type == T_RPAR)
	   token_type = get_token();
	else rwbuf_err();
     else rwbuf_err(); }

   /* parse list */
   /* if((aux_cnt=list_parse()) == FAIL) return(FAIL); */

   aux_cnt = list_parse();
 if(aux_cnt != FAIL)
  {log_exp(&as_index,&as_offset);
   if (as_index == FAIL) return_value = FAIL;
   else if (symbol_table[as_index].mode1 != T_LOGICAL &&
	    symbol_table[as_index].mode2 != T_PARALLEL)
     {print_msg (LOGEXP_ERR, token_buf);
      return FAIL;}

   sort_dx = FAIL; slog_dx = FAIL; slog_off = FAIL;
   if(strcmp(token_buf,"SORTED") == 0)
     {token_type = get_token();
      if(strcmp(token_buf,"BY") == 0) token_type = get_token();
      if(token_type == T_ID)
	if((sort_dx =symtab_fetch(token_size,token_buf)) == FAIL)
	   {print_msg(UNDEF_ERR,token_buf); return(FAIL);}
     log_exp(&slog_dx,&slog_off);
     }

   if (token_type != T_EOS)
	{print_msg(EOS_ERR, token_buf);
	 return FAIL;}
   else token_type = get_token();

/* T_SETSCOPE */
/*   print_opcode("stack_scope_",T_STACK_SCOPE,T_NONE,T_NONE);
   print_args(off_exp1(as_index,as_offset), NULL, NULL, NULL, NULL); */
/* T_LOOP */
   xx_get_dx = get_symtab_temp(T_LOGICAL,T_PARALLEL,W_LOGICAL);
   xx_temp_dx = get_symtab_temp(T_LOGICAL,T_PARALLEL,W_LOGICAL);
   xx_min_dx = get_symtab_temp(T_LOGICAL,T_PARALLEL,W_LOGICAL);
   print_opcode("mvpa_",T_MVPA,T_LOGICAL,T_PARALLEL);
   print_args(off_exp1(as_index,as_offset),
	      off_exp2(xx_get_dx,SUCCESS),NULL,NULL,NULL);
   print_opcode("loop_",T_LOOP,T_NONE,T_NONE);
   print_args(loop_label,NULL,NULL,NULL,NULL);
   print_opcode("until_",T_UNTIL,T_IFNANY,T_PARALLEL);
   print_args(off_exp1(xx_get_dx,SUCCESS),exit_label,NULL,NULL,NULL);
   print_opcode("stack_scope_",T_STACK_SCOPE,T_NONE,T_NONE);
   print_args(off_exp1(xx_get_dx,SUCCESS), NULL, NULL, NULL, NULL);

/* T_GET if normal, T_MINDEX if sorted */

   if(sort_dx != FAIL)
     {print_opcode("mindex_",T_MINDEX,T_NONE,T_NONE);
      print_args(off_exp1(slog_dx,slog_off),
		 off_exp2(xx_min_dx,SUCCESS),NULL,NULL,NULL);}
   else
      xx_min_dx = xx_get_dx;

   print_opcode("get_",T_GET,T_NONE,T_NONE);
   print_args(off_exp1(xx_min_dx,SUCCESS),
	      off_exp2(xx_temp_dx,SUCCESS),gexit_label,NULL,NULL);

   list_pt =0;
   cnt=0;
   while((id_index=next_elem()) != FAIL)
     {/* two entries per field */
      if((id_offset = next_elem()) == FAIL) id_offset=SUCCESS;
      a_words = msg_aux_words(id_index,&a_width);
      out_bits = a_width;
      bit_dx = SUCCESS;
      save_id_offset = id_offset;
      if(code_type == EMULATE) int_off=0;
      /* in dump, 32 bit reals and long integers and hex should generate only one entry */
      if(a_width == 16 && (symbol_table[id_index].mode1 == T_REAL ||
			   symbol_table[id_index].mode1 == T_LONGINT ||
			   symbol_table[id_index].mode1 == T_HEX)) a_words=0;
      for(j=0; j<= a_words; j++) /* iterate for every column of output */
	{sc_temp_dx = get_symtab_temp(symbol_table[id_index].mode1,T_SCALAR,
				      symbol_table[id_index].width);
	 pc_itoa(symbol_table[id_index].width,c_idsize);
	 bufsz_dx = get_const(c_idsize,T_DEC_CONST);
	 print_opcode("mvpa_",T_MVPA,symbol_table[id_index].mode1,T_SCALAR);
	 print_args(off_exp1(id_index,id_offset),
		    off_exp2(sc_temp_dx,SUCCESS),
		    off_exp3(xx_temp_dx,SUCCESS),
		    off_exp4(bufsz_dx,SUCCESS),
		    NULL);
	 print_opcode("dump_",T_DUMP,symbol_table[id_index].mode1,T_SCALAR);
	 print_args(off_exp1(obuf_index,obuf_offset),
		    off_exp2(sc_temp_dx,SUCCESS),
		    off_exp3(symbol_table[id_index].iospec,SUCCESS),
		    NULL,NULL);}
/* delineate varibles with a blank */
      print_opcode("print_del",T_PRINT_DEL,T_NONE,T_NONE);
      print_args(off_exp1(obuf_index,obuf_offset),NULL,NULL,NULL,NULL);
     }
/* T_NL */
   print_opcode("print_nl",T_NL,T_NONE,T_NONE);
   print_args(off_exp1(obuf_index,obuf_offset),NULL,NULL,NULL,NULL);

   print_opcode("pop_scope",T_POP_SCOPE,T_NONE,T_NONE);
   print_args(NULL,NULL,NULL,NULL,NULL);

/* T_RELEASE */
   print_opcode("release",T_RELEASE,T_NONE,T_NONE);
   print_args(off_exp1(xx_temp_dx,SUCCESS),
	      off_exp2(xx_get_dx,SUCCESS),NULL,NULL,NULL);

/* T_ENDcode */
   if(sort_dx == FAIL)
      {print_opcode("endget",T_ENDGET,T_NONE,T_NONE);
       print_args(gexit_label,NULL,NULL,NULL,NULL);}
   print_opcode("endloop",T_ENDLOOP,T_NONE,T_NONE);
   print_args(exit_label,loop_label,NULL,NULL,NULL);
/* restore scope */
/*   print_opcode("pop_scope",T_POP_SCOPE,T_NONE,T_NONE);
   print_args(NULL,NULL,NULL,NULL,NULL);*/
}
else
{if(token_type != T_EOS)
    return(FAIL);
 if (as_index == FAIL) return_value = FAIL;
 token_type = get_token();
 list_pt =0;
 cnt=0;
 while((id_index=next_elem()) != FAIL)
     {/* two entries per field */
      if((id_offset = next_elem()) == FAIL) id_offset=SUCCESS;
      a_words = msg_aux_words(id_index,&a_width);
      out_bits = a_width;
      bit_dx = SUCCESS;
      save_id_offset = id_offset;
      if(code_type == EMULATE) int_off=0;
      /* in dump, 32 bit reals and long integers and hex should generate only one entry */
      if(a_width == 16 && (symbol_table[id_index].mode1 == T_REAL ||
			   symbol_table[id_index].mode1 == T_LONGINT ||
			   symbol_table[id_index].mode1 == T_HEX)) a_words=0;
      for(j=0; j<= a_words; j++) /* iterate for every column of output */
	{pc_itoa(symbol_table[id_index].width,c_idsize);
	 bufsz_dx = get_const(c_idsize,T_DEC_CONST);
	 print_opcode("dump_",T_DUMP,symbol_table[id_index].mode1,T_SCALAR);
	 print_args(off_exp1(obuf_index,obuf_offset),
		    off_exp2(id_index, id_offset),
		    off_exp3(symbol_table[id_index].iospec,SUCCESS),
		    NULL,NULL);}
/* delineate varibles with a blank */
      print_opcode("print_del",T_PRINT_DEL,T_NONE,T_NONE);
      print_args(off_exp1(obuf_index,obuf_offset),NULL,NULL,NULL,NULL);
     }
/* T_NL */
   print_opcode("print_nl",T_NL,T_NONE,T_NONE);
   print_args(off_exp1(obuf_index,obuf_offset),NULL,NULL,NULL,NULL);
}
   return(return_value);
}

/* msg_aux_words calculates the number of HOST words needed to ouput
   the bin,oct or hex variable the only types which are partitionabled.
   Unlike print, real and longint are not partitioned.
*/
#define IO_SIZE_REAL32 32
#define IO_SIZE_LONGINT32 32

msg_aux_words(indx,a_width)
int indx,*a_width;
{
  int aux_size,width;

  width = symbol_table[indx].width;
  aux_size = 0; *a_width = 0;
  switch(symbol_table[indx].mode1)
    {case T_BIN    : aux_size= (width-1)/IO_SIZE_BIN; *a_width=IO_SIZE_BIN; break;
     case T_OCT    : aux_size= (width-1)/IO_SIZE_OCT; *a_width=IO_SIZE_OCT; break;
     case T_HEX    : aux_size= (width-1)/IO_SIZE_HEX; *a_width=IO_SIZE_HEX; break;
     case T_CHAR   : /*aux_size=(width-1)/IO_SIZE_CHAR;*/
/* mvpa scalar is designed to move entire field into scalar */
		     aux_size = 0; *a_width=IO_SIZE_CHAR; break;
     case T_LOGICAL: aux_size= (width-1)/IO_SIZE_LOGICAL; *a_width=IO_SIZE_LOGICAL; break;
     case T_CARD   : *a_width = IO_SIZE_CARD; break;
     case T_INT    : /* W_INT is used in p1_declare.c */
		     *a_width = IO_SIZE_INT;
		     if(width > SIZE_HOST)
			  printf("WARNING - can not io scalar integer greater than %d bits.\n",SIZE_HOST);
		     break;
     case T_REAL   : *a_width = IO_SIZE_REAL32; aux_size= (width-1)/IO_SIZE_REAL32;break;
     case T_LONGINT: *a_width = IO_SIZE_LONGINT32; aux_size= (width-1)/IO_SIZE_LONGINT32;
		     if(width > 32)
							  printf("WARNING - can not read or print an integer size greater than 32 bits.  Use bin, oct or hex type.\n");
		     break;
     default:  printf("%d ERROR - Default type in msg_aux_words, token=%s, mode1=%d\n.",
		      symbol_table[indx].tokpts, symbol_table[indx].mode1);
		     *a_width = IO_SIZE_INT;
		     break;
    }
  if(width < *a_width){ *a_width = width; aux_size=0;}
  return(aux_size);
}

