/* 910415 P1_READ.C */

#include "stdarg.h"
#include "stdio.h"
#include "ctype.h"
#include "string.h"
#include "alloc.h"
#include "p1_common.h"
#include "p1_parser.h"
#include "p1_scanner.h"
#include "stdio.h"

#define IO_SIZE_BIN     8   /* The number of bits needed to make an */
#define IO_SIZE_HEX    16   /* 8 char or 32 bit output               */
#define IO_SIZE_OCT    15   /* must be less than host word size */
#define IO_SIZE_CHAR   16   /* 4 char per 32 bits */
#define IO_SIZE_LOGICAL 8
#define IO_SIZE_CARD   16
#define IO_SIZE_INT    16
#define IO_SIZE_LONGINT 16
#define IO_SIZE_REAL   16   /* must be less than host word size */

char *off_exp1();
char *off_exp2();
char *off_exp3();
char *off_exp4();
char *off_exp5();
char *off_exp6();

/*  This routine parses statements of the form:

print {(rbuf)} a[$], b[$], c[$] in d[$];

It causes the specified fields of all allocated cells of d[$]
   to be printed in tabular form.

NOTE: The mode of the data is supplied in two places on input and
      output, so that pass2 can determin where conversion is done:
      conversion in host:    READ   PRINT
      conversion in array:   INPUT  OUTPT
*/

int print_()
{ int return_value,as_index,cnt,sc_temp_dx,sc_temp2_dx,zero_dx,one_dx;
  int buf_index,sc_count_dx,id_index,id_offset;
  int buf_offset,as_offset;
  int noofp, bufsz_dx;
  int j,a_words,a_width,bit_dx,new_off_dx,out_bits,out_bits_dx;
  char strbuf[MAX_NO_OUT*(MAX_ID_SIZE+1)],offset[10],c_noofp[10];
  char *loop_label, *exit_label, *noerr_label, *endif_label;
  int aux_cnt;
  int save_id_offset;
  int int_off;
  int obuf_index,obuf_offset;
  int outbf_sz; /* variable for parameter OUTBF_SIZE, for staran 6144 */

  if(debug == 2) printf("In print() ...\n");

  outbf_sz = OUTBF_SIZE;

  return_value=SUCCESS;
  buf_index = SC_IO_BUFFER;
  loop_label=make_label("PT$S",++loop_count);
  exit_label=make_label("PT$E",loop_count);
  noerr_label=make_label("PT$N",loop_count);
  endif_label=make_label("PT$F",loop_count);

  sc_count_dx = get_symtab_temp(T_INT,T_SCALAR,W_INT);

  obuf_index = sysot_dx; obuf_offset = SUCCESS;
  if((token_type = get_token()) == T_LPAR)
    {token_type = get_token();
     if(element(&obuf_index,&obuf_offset) != FAIL)
	if(token_type == T_RPAR)
	   token_type = get_token();
	else rwbuf_err();
     else rwbuf_err(); }

  /* parse list */
  if((aux_cnt=list_parse()) == FAIL)
    { printf("%d ERROR - list parse failure\n",linenum);
      return(FAIL);}

   log_exp(&as_index,&as_offset);
   if (as_index == FAIL) return_value = FAIL;
   else if (symbol_table[as_index].mode1 != T_LOGICAL &&
	    symbol_table[as_index].mode2 != T_PARALLEL)
     {print_msg (LOGEXP_ERR, token_buf);
      return FAIL;}
   else
     {if (token_type != T_EOS)
	{print_msg(EOS_ERR, token_buf);
	 return FAIL;}
      else token_type = get_token();
     }
   noofp = outbf_sz/((save_cnt/2)+aux_cnt);
   strcpy(strbuf,"");
   cnt = 0;
   print_opcode("fstout_",T_FSTOUT,NULL,NULL);
   print_args(off_exp2(as_index,as_offset),NULL,NULL,NULL,NULL);
   while((id_index=next_elem()) != FAIL)
/*2*/{if((id_offset = next_elem())== FAIL) id_offset=SUCCESS;
      a_words = aux_words(id_index,&a_width);
      out_bits = a_width;
      bit_dx = SUCCESS;
      save_id_offset = id_offset;
      if( code_type == EMULATE ) int_off=0; /* emulator counts bits backwards */
      for(j=0; j<= a_words; j++) /* iterate for every column of output */
/*3*/   {if(a_words != 0)
/*4*/      {if ( !(code_type == EMULATE)) int_off = (a_words-j)*a_width;
	    pc_itoa(int_off,offset);
	    bit_dx = get_const(offset,T_DEC_CONST);
	    /* modified for left adjusted char field */
	    if(symbol_table[id_index].mode1 == T_CHAR)
	      out_bits = symbol_table[id_index].width-j*a_width;
	    else
	      out_bits = symbol_table[id_index].width-(a_words-j)*a_width;
	    if(out_bits>a_width) out_bits = a_width;
	    if(code_type == EMULATE) int_off += out_bits;
	    id_offset = save_id_offset; /* restore for later iterations */
	    if(id_offset == SUCCESS)
	      id_offset = bit_dx;
	    else
	      if((new_off_dx = get_symtab_temp(T_INT,T_SCALAR,W_INT))
		  == FAIL) return(FAIL);
	      else
/*5*/           {print_opcode("add_",T_ADD,T_INT,T_SCALAR);
		 print_args(off_exp1(id_offset,SUCCESS),
			    off_exp2(bit_dx,SUCCESS),
			    off_exp3(new_off_dx,SUCCESS),NULL,NULL);
/*5*/            id_offset=new_off_dx;}
/*4*/      }
	 pc_itoa(out_bits,offset);  /* use offset temporarly */
	 out_bits_dx = get_const(offset,T_DEC_CONST);
	 print_opcode("outpt_",T_OUTPT,symbol_table[id_index].mode1,
		      symbol_table[id_index].mode2);
	 print_args(off_exp1(id_index,id_offset),
		    off_exp2(out_bits_dx,SUCCESS),NULL,NULL,NULL);
	 if((strlen(strbuf)+strlen(symbol_table[id_index].tokpts)+1)<
	     (MAX_NO_OUT*(MAX_ID_SIZE+1)))
	   {strcat(strbuf,symbol_table[id_index].tokpts);
	    strcat(strbuf,",");}
	 pc_itoa(noofp*cnt++,offset);
	 buf_offset = get_const(offset,T_DEC_CONST);
	 print_opcode("colapse",T_COLAPSE,symbol_table[id_index].mode1,
		      symbol_table[id_index].mode2);
	 print_args(off_exp1(buf_index,buf_offset),
		    off_exp2(sc_count_dx,SUCCESS),
		    off_exp3(id_index,SUCCESS),
		    off_exp4(out_bits_dx,SUCCESS),NULL);
/*3*/   }
/*2*/}

/* BEG_PRINT */
   print_opcode("beg_print",T_BEGPRINT,T_NONE,T_NONE);
   print_args(off_exp1(obuf_index,obuf_offset),
				  off_exp2(as_index,as_offset),strbuf,NULL,NULL);
   /* test for buffer overflow */
   pc_itoa(noofp,c_noofp);
   sc_temp_dx = get_symtab_temp(T_INT,T_SCALAR,W_INT);
   bufsz_dx = get_const(c_noofp,T_DEC_CONST);
   print_opcode("gt",T_GT,T_INT,T_SCALAR);
   print_args(symbol_table[sc_count_dx].tokpts,symbol_table[bufsz_dx].tokpts,
	      symbol_table[sc_temp_dx].tokpts,NULL,NULL);
/* T_IF - must be scalar so that parallel stack is not used */
   print_opcode("if_",T_IF,T_NONE,T_SCALAR);
   print_args(symbol_table[sc_temp_dx].tokpts,noerr_label,NULL,NULL,NULL);
   print_opcode("msg",T_MSG,T_NONE,T_NONE);
   print_args("SYSOT","ERROR - I/O BUFFER OVERFLOW ON PRINT - SOME DATA LOST.",
	      NULL,NULL,NULL);
   print_opcode("else_",T_ELSE,T_NONE,T_SCALAR);
   print_args(endif_label,noerr_label,NULL,NULL,NULL);
   print_opcode("endif_",T_ENDIF,T_NONE,T_SCALAR);
   print_args(endif_label,NULL,NULL,NULL,NULL);

/* sc_mem[temp$]=0; */
/* sc_temp_dx = get_symtab_temp(T_INT,T_SCALAR,W_INT);*/
/* seperate line because may generate a quadruple */
   zero_dx = get_const("0",T_DEC_CONST);
   print_opcode("mvsc_",T_MVSC,symbol_table[zero_dx].mode1,T_SCALAR);
   print_args(symbol_table[zero_dx].tokpts,
	      symbol_table[sc_temp_dx].tokpts,NULL,NULL,NULL);
/* FIRST */
   sc_temp2_dx = get_symtab_temp(T_INT,T_SCALAR,W_INT);
/* T_LOOP */
   print_opcode("loop_",T_LOOP,T_NONE,T_NONE);
   print_args(loop_label,NULL,NULL,NULL,NULL);
/* T_UNTIL sc_mem[temp$] >= sc_mem[k] */
   print_opcode("ge",T_GE,T_INT,T_SCALAR);
   print_args(symbol_table[sc_temp_dx].tokpts,
	      symbol_table[sc_count_dx].tokpts,
	      symbol_table[sc_temp2_dx].tokpts,NULL,NULL);
   print_opcode("until_",T_UNTIL,T_NONE,T_SCALAR);
   print_args(symbol_table[sc_temp2_dx].tokpts,exit_label,NULL,NULL,NULL);
/* T_PRINT */
   list_pt =0;
   cnt=0;
   while((id_index=next_elem()) != FAIL)
     {a_words = aux_words(id_index,&a_width);
      for(j=0; j<= a_words; j++) /* iterate for every column of output */
	{pc_itoa(noofp*cnt++,offset);
	 buf_offset = get_const(offset,T_DEC_CONST);
	 print_opcode("sprint_",T_PRINT,symbol_table[id_index].mode1,
		      symbol_table[id_index].mode2);
	 print_args(off_exp1(obuf_index,obuf_offset),
		    off_exp2(buf_index,buf_offset),
		    off_exp3(sc_temp_dx,SUCCESS),
						  off_exp4(symbol_table[id_index].iospec,SUCCESS),
						  NULL);}
/* delineate varibles with a blank */
      print_opcode("print_del",T_PRINT_DEL,T_NONE,T_NONE);
      print_args(off_exp1(obuf_index,obuf_offset),NULL,NULL,NULL,NULL);
      next_elem();  /* two entries per field */
     }
/* T_NL */
   print_opcode("print_nl",T_NL,T_NONE,T_NONE);
   print_args(off_exp1(obuf_index,obuf_offset),NULL,NULL,NULL,NULL);
/* incr */
  /* use seperate line for get_const since it may generate quadruples */
   one_dx = get_const("1",T_DEC_CONST);
   print_opcode("add",T_ADD,T_INT,T_SCALAR);
   print_args(symbol_table[sc_temp_dx].tokpts,
	      symbol_table[one_dx].tokpts,
	      symbol_table[sc_temp_dx].tokpts,NULL,NULL);
/* T_ENDLOOP */
   print_opcode("endloop",T_ENDLOOP,T_NONE,T_NONE);
   print_args(exit_label,loop_label,NULL,NULL,NULL);
/* T_ENDPRINT */
   print_opcode("endprint",T_ENDPRINT,T_NONE,T_NONE);
   print_args(NULL,NULL,NULL,NULL,NULL);
   return(return_value);
}

/* This routine parses statements of the form

      read  {(rbuf)} a[$],b[$],c[$] in d[$];

   It generates quadruples which will read values and store them in
   buffers untila a blank line is input.  The values are then moved
   to associative memory.  Memory is allocated in the association
   for them automatically.
*/
/*int read_(mode) mode=1 for suppress insufficient data - not imp
	   deleate int mode below when fixed                       */
int read_(mode,code)
int mode;
unsigned int code;
{ int as_index,cnt,sc_temp_dx,sc_temp2_dx,zero_dx,one_dx;
  int buf_index,id_index;
  int buf_offset;
  int int_off;
  int as_offset,bufsz_dx;
  int noofp;
  int mode2;
  char strbuf[MAX_NO_OUT*(MAX_ID_SIZE+1)],offset[10],c_noofp[10];
  char *loop_label, *exit_label, *noerr_label, *endif_label;
  char *retry_label; /* added 880229 jlp */
  int aux_cnt, a_words, a_width, out_bits, bit_dx, save_id_offset;
  int id_offset;
  int j,new_off_dx;
  int out_bits_dx;
  int obuf_index,obuf_offset;
  int outbf_sz;
  int log_dx,log_off; /* temp indexx and offset for subscript */

  if(debug == 2) printf("In read() ...\n");

  outbf_sz = OUTBF_SIZE;

  buf_index = SC_IO_BUFFER;
  loop_label=make_label("PT$S",++loop_count);
  exit_label=make_label("PT$E",loop_count);
  noerr_label=make_label("PT$N",loop_count);
  retry_label=make_label("PT$R",loop_count);
  endif_label=make_label("PT$F",loop_count);

  obuf_index = sysin_dx; obuf_offset = SUCCESS;/* default values */
  if((token_type = get_token()) == T_LPAR)
    {token_type = get_token();
     if(element(&obuf_index,&obuf_offset) != FAIL)
	if(token_type == T_RPAR)
	   token_type = get_token();
	else rwbuf_err();
     else rwbuf_err(); }

  /* parse list */
  if((aux_cnt=list_parse()) == FAIL) return(FAIL);
  if(token_type == T_IN)
	 {code = T_COREAD; token_type = get_token();}
  as_index=symtab_fetch(token_size,token_buf); /* association name */
  token_type=get_token(); /* consume [ */
  subscript(as_index,&log_dx,&log_off);
  as_index = log_dx;
  as_offset = log_off;
  mode2 = 0;
  if(token_type == T_IN)
     {token_type = get_token();
      if(token_type == T_SILENCE)
	{mode2 = T_SILENT;
	 token_type = get_token();}
     }
  if(token_type != T_EOS) print_msg(EOS_ERR,token_buf);
  else token_type = get_token();
  if(as_index == FAIL) return FAIL;
  noofp = outbf_sz/((save_cnt/2)+aux_cnt);

  /* T_BEGREAD - print header */
  strcpy(strbuf,"");
  while((id_index=next_elem()) != FAIL)
    {strcat(strbuf,symbol_table[id_index].tokpts);
     strcat(strbuf,","); list_pt++; }
  print_opcode("beg_read",T_BEGREAD,T_NONE,mode2);
  print_args(off_exp1(sysot_dx,SUCCESS),
	     symbol_table[as_index].tokpts,strbuf,NULL,NULL);
/* sc_mem[temp$]=0; the input count variable */
  sc_temp_dx = get_symtab_temp(T_INT,T_SCALAR,W_INT);
/* seperate line because may generate a quadruple */
  zero_dx = get_const("0",T_DEC_CONST);
  print_opcode("mvsc_",T_MVSC,symbol_table[zero_dx].mode1,T_SCALAR);
  print_args(symbol_table[zero_dx].tokpts,
	     symbol_table[sc_temp_dx].tokpts,NULL,NULL,NULL);
/* sc_mem[temp2$]=0; the until test variable  i.e. FALSE  */
  sc_temp2_dx = get_symtab_temp(T_INT,T_SCALAR,W_INT);
  print_opcode("mvsc_",T_MVSC,symbol_table[zero_dx].mode1,T_SCALAR);
  print_args(symbol_table[zero_dx].tokpts,
	     symbol_table[sc_temp2_dx].tokpts,NULL,NULL,NULL);
/* T_LOOP */
  print_opcode("loop_",T_LOOP,T_NONE,T_NONE);
  print_args(loop_label,NULL,NULL,NULL,NULL);
/* T_READLN */ /* mode = 1 if insufficient data mes to be supressed */
  print_opcode("read_ln",T_READLN,T_NONE,mode);/*below modified 880229 jlp*/
  print_args(off_exp1(obuf_index,obuf_offset),
				 symbol_table[sc_temp2_dx].tokpts,retry_label,NULL,NULL);
/*T_UNTIL sc_mem[temp2$] == TRUE*/
  print_opcode("until_",T_UNTIL,T_NONE,T_SCALAR);
  print_args(symbol_table[sc_temp2_dx].tokpts,exit_label,NULL,NULL,NULL);
/*T_READ */
  list_pt =0;
  cnt=0;
  pc_itoa(noofp,c_noofp);
  while((id_index=next_elem()) != FAIL)
    {a_words = aux_words(id_index,&a_width);
     for(j=0; j <= a_words; j++)
       {pc_itoa(noofp*cnt++,offset);
	buf_offset = get_const(offset,T_DEC_CONST);
	print_opcode("read_",T_READ,symbol_table[id_index].mode1,
		     symbol_table[id_index].mode2);
	pc_itoa(symbol_table[id_index].width,offset);
	print_args(off_exp1(buf_index,buf_offset),
		   off_exp2(sc_temp_dx,SUCCESS),offset,retry_label,NULL);
       }
     list_pt++;
    }
/* incr  */
  one_dx = get_const("1",T_DEC_CONST);
  print_opcode("add",T_ADD,T_INT,T_SCALAR);
  print_args(symbol_table[sc_temp_dx].tokpts,
	     symbol_table[one_dx].tokpts,
	     symbol_table[sc_temp_dx].tokpts,NULL,NULL);
/* T_ENDLOOP */
  print_opcode("endloop",T_ENDLOOP,T_NONE,T_NONE);
  print_args(exit_label,loop_label,NULL,NULL,NULL);

/* test for buffer overflow */
  bufsz_dx = get_const(c_noofp,T_DEC_CONST);
  print_opcode("gt",T_GT,T_INT,T_SCALAR);
  print_args(symbol_table[sc_temp_dx].tokpts,symbol_table[bufsz_dx].tokpts,
	     symbol_table[sc_temp2_dx].tokpts,NULL,NULL);
/* T_IF - must be scalar so that parallel stack is not used */
  print_opcode("if_",T_IF,T_NONE,T_SCALAR);
  print_args(symbol_table[sc_temp2_dx].tokpts,noerr_label,NULL,NULL,NULL);
  print_opcode("msg",T_MSG,T_NONE,T_NONE);
  print_args("SYSOT","ERROR - I/O BUFFER OVERFLOW ON READ - SOME DATA OVERWRITTEN.",
	NULL,NULL,NULL);
  print_opcode("else_",T_ELSE,T_NONE,T_SCALAR);
  print_args(endif_label,noerr_label,NULL,NULL,NULL);
  print_opcode("endif_",T_ENDIF,T_NONE,T_SCALAR);
  print_args(endif_label,NULL,NULL,NULL,NULL);

/* move data to array */
/* set mode to T_REREAD, T_COREAD or T_READ */
  print_opcode("ioalloc2",T_IOALLOC,T_NONE,code/SIZE_MODE);
  print_args(off_exp1(as_index,as_offset),
	     off_exp2(sc_temp_dx,SUCCESS),
	     NULL,NULL,NULL);
  list_pt = 0;
  cnt = 0;
  while((id_index=next_elem()) != FAIL)
/*2*/{if((id_offset = next_elem())== FAIL) id_offset=SUCCESS;
      a_words = aux_words(id_index,&a_width);
      out_bits = a_width;
      bit_dx = SUCCESS;
      save_id_offset = id_offset;
      if( code_type == EMULATE ) int_off=0; /* emulator counts bits backwards */
	for(j=0; j<= a_words; j++) /* iterate for every column of input */
/*3*/     {if(a_words != 0)
/*4*/        {if ( !(code_type == EMULATE)) int_off = (a_words-j)*a_width;
	      pc_itoa(int_off,offset);
	      bit_dx = get_const(offset,T_DEC_CONST);
	      /* modified for left adjusted char field */
	      if(symbol_table[id_index].mode1 == T_CHAR)
		out_bits = symbol_table[id_index].width-j*a_width;
	      else
		out_bits = symbol_table[id_index].width-(a_words-j)*a_width;
	      if(out_bits>a_width) out_bits = a_width;
	      if(code_type == EMULATE) int_off += out_bits;
	      id_offset = save_id_offset; /* restore for later iterations */
	      if(id_offset == SUCCESS)
		id_offset = bit_dx;
	      else
		if((new_off_dx = get_symtab_temp(T_INT,T_SCALAR,W_INT))
		    == FAIL) return(FAIL);
		else
/*5*/             {print_opcode("add_",T_ADD,T_INT,T_SCALAR);
		   print_args(off_exp1(id_offset,SUCCESS),
			      off_exp2(bit_dx,SUCCESS),
			      off_exp3(new_off_dx,SUCCESS),NULL,NULL);
/*5*/              id_offset=new_off_dx;}
/*4*/        }
	   pc_itoa(out_bits,offset);  /* use offset temporarly */
	   out_bits_dx = get_const(offset,T_DEC_CONST);
	   pc_itoa(noofp*cnt++,offset);
	   buf_offset = get_const(offset,T_DEC_CONST);
	   print_opcode("expand",T_EXPAND,symbol_table[id_index].mode1,
					  symbol_table[id_index].mode2);
	   print_args(off_exp1(buf_index,buf_offset),
		      off_exp2(id_index,SUCCESS),
		      off_exp3(out_bits_dx,SUCCESS),NULL,NULL);
	   print_opcode("input_",T_INPUT,symbol_table[id_index].mode1,
			 symbol_table[id_index].mode2);
	   print_args(off_exp1(id_index,id_offset),
		     off_exp2(out_bits_dx,SUCCESS),NULL,NULL,NULL);
/*3*/     }
/*2*/ }
/* T_ENDREAD */
     print_opcode("endread_",T_ENDREAD,T_NONE,T_NONE);
     print_args(NULL,NULL,NULL,NULL,NULL);

  return(SUCCESS);
}


int list_parse()
/* This routine parses lists of the form
     field1[index,exp] field2[index,exp] ... fieldn[index,exp] in assoc[$];
   It saves all of the fields and their offsets on a stack.
   CAN NOT use add_off because may have
   multiple instances of the same variable in the statment. i.e.
   print  a[$,1] a[$,2] in d[$] since the last offset would be used for
   all of the id's (i.e. a).    The keyword IN is parsed, and
   the nextoken is scanned. Next_elem() reads the items off the list.
   If no offset, SUCCESS is returned by subscript and it is inserted.
   The list may be reread by setting list_pt to zero.
   List_parse executes add_offset for the association variable.

   aux_cnt for is hex, oct and bin integers.  It specifies the additional
   number of standard width columns (8 characters) needed to output a
   long field.
 */
{
  int field_dx,log_dx,log_off,a_width;
  int aux_cnt;

  if(debug == 100)
	 printf("In list_parse\n");

  save_cnt=0;
  list_pt=0;
  aux_cnt=0;
  while(token_type == T_ID && save_cnt<LIST_STACK_SIZE)
    {if(debug == 100)
	printf("   processing %s\n",token_buf);
/*   if((field_dx = list_stack[save_cnt++]=symtab_fetch(token_size,token_buf))*/
     if((field_dx = symtab_fetch(token_size,token_buf))
	== FAIL) {print_msg(UNDEF_ERR,token_buf); return(FAIL);}
     token_type=get_token();
     subscript(field_dx,&log_dx,&log_off);
     list_stack[save_cnt++] = log_dx;
     list_stack[save_cnt++] = log_off;
     /* subscript calls get_token */
     aux_cnt += aux_words(field_dx,&a_width);
     if(token_type == T_COMMA) token_type = get_token();
    };

  if(save_cnt >= LIST_STACK_SIZE)
    printf("%d ERROR - list stack overflow, size=%d\n",linenum,LIST_STACK_SIZE);


/*
  if(token_type != T_IN && token_type != T_CONTIG)
	 { print_msg(IN_ERR,token_buf);
		return(FAIL);};
  token_type = get_token();
*/
  if(token_type == T_IN || token_type == T_CONTIG)
     {token_type = get_token();
      return(aux_cnt);}
  else
   { if(token_type != T_EOS)
       print_msg(IN_ERR,token_buf);
     return(FAIL);};
}


next_elem()
{
  int result;

  if(list_pt < 0 )
    {printf("ERROR - list_pt has negative value %d\n",list_pt);
     result = FAIL;}
  else if(list_pt < save_cnt)
    {result =list_stack[list_pt];}
  else result = FAIL;
  list_pt++;

  return(result);
}



/* aux_words calculates the number of HOST words needed to ouput
   the bin,oct or hex variable the only types which are partitionable
*/

aux_words(indx,a_width)
int indx,*a_width;
{
  int aux_size,width;

  width = symbol_table[indx].width;
  aux_size = 0; *a_width = 0;
  switch(symbol_table[indx].mode1)
    {case T_BIN    : aux_size= (width-1)/IO_SIZE_BIN; *a_width=IO_SIZE_BIN; break;
     case T_OCT    : aux_size= (width-1)/IO_SIZE_OCT; *a_width=IO_SIZE_OCT; break;
     case T_HEX    : aux_size= (width-1)/IO_SIZE_HEX; *a_width=IO_SIZE_HEX; break;
     case T_CHAR   : aux_size=(width-1)/IO_SIZE_CHAR;*a_width=IO_SIZE_CHAR; break;
     case T_LOGICAL: aux_size= (width-1)/IO_SIZE_LOGICAL; *a_width=IO_SIZE_LOGICAL; break;
     case T_CARD   : *a_width = IO_SIZE_CARD; break;
     case T_INT    : /* W_INT is used in p1_declare.c */
		     *a_width = IO_SIZE_INT;
		     if(width > SIZE_HOST)
			  printf("WARNING - can not io scalar integer greater than %d bits.\n",SIZE_HOST);
		     break;
     case T_REAL   : *a_width = IO_SIZE_REAL; aux_size= (width-1)/IO_SIZE_REAL;break;
     case T_LONGINT: *a_width = IO_SIZE_LONGINT; aux_size= (width-1)/IO_SIZE_LONGINT;
		     if(width > 32)
							  printf("WARNING - can not read or print an integer size greater than 32 bits.  Use bin, oct or hex type.\n");
		     break;
     default:  printf("%d ERROR - Default type in aux_words, token=%s, mode1=%d\n",
		      linenum,symbol_table[indx].tokpts, symbol_table[indx].mode1);
		      *a_width = IO_SIZE_INT;
		      break;
    }
  if(width < *a_width){ *a_width = width; aux_size=0;}
  return(aux_size);
}

rwbuf_err()
{ /* RWBUF_ERR - Syntax error in read or print statement at */
  print_msg(RWBUF_ERR,token_buf);
  return(FAIL);
}
