/* 910415 P1_RETURN */

#include "stdarg.h"
#include "stdio.h"
#include "ctype.h"
#include "string.h"
#include "alloc.h"
#include "p1_common.h"
#include "p1_parser.h"
#include "p1_scanner.h"

/* ===========================================================================

   function name : return
   input	        : ---
   output	     : ---
   return value  : ret_value	- SUCCESS, if no error is detected
				                  - FAIL, otherwise if an error occured

   global vars   : token_type 	- type of current token
		             token_buf	- current token string
		             symbol_table	- symbol table data structure
		             debug		- debugging statement flag
		             module_flag	- type of module being parsed

   description	  : This routine parses the return statement in the subroutine
		             module.

			RETURN   <--  return ;

		  It first check if the module being parsed is a subroutine
		  module. If it is not, then it will print a error message.

=========================================================================== */

int return_()
{
   int ret_value;		/* varaible for return value */


   if (debug == 2)
      printf ("In return_().....................................\n");

   ret_value = SUCCESS;
   if (module_flag == T_SUBROUTINE)
     {if (token_type != T_EOS)
        {ret_value = FAIL;
         print_msg (EOS_ERR, token_buf);}
      else
        {print_opcode ("return", T_RETURN, T_NONE, T_NONE);
         print_args (NULL, NULL, NULL, NULL, NULL);
         token_type = get_token();}
     }
   else
     {print_msg(RETURN_ERR, NULL);
      ret_value = FAIL;}

   if (debug == 2)
      printf ("return_() returning ret_value : %d\n", ret_value);

   return(ret_value);

} /* end of return_() */
