#ifndef		P1_SCANNER
#define     P1_SCANNER

/* ==========================================================================

   This file contains preprocessor definitions and global data structure
   declarations for use with 'genicode' intermediate code generator.

============================================================================ */


/* DEFINITIONS FOR COMMONLY USED CHARACTERS */

#define EOB             '\0'

/* DEFINITIONS FOR SCANNER CONSTANTS */

#define BUF_SIZE        80              /* size of input buffers */
#define NUM_BUFFERS     2               /* number of input buffers */
#define ALPHA           101             /* types of characters */
#define NUMERIC         102
#define SPECIAL         103
#define WHITESPACE      104
#define ILLEGAL         105


/* AL VARIABLE DECLARATIONS */

 int     count,   /* charnum - character position in the line */
	current_buf,    /* index to 'buffer' array */
	eofflg,         /* end of file flag */
	linenum,        /* current line number */
	current_char,   /* current character */
	next_char,      /* next character */
	in_comment,     /* whether or not scanner is in a comment */
	previous_type,  /* previous token type */
	fill_buf_flg,   /* flag for whether to fill buffer or reuse */
	next_char_save, /* save the next character of the current active file*/
	use_next_char_save, /* flag for using the next_char_save */
	upper,          /* convert to upper case flag */
	use_once_flag;  /* flag for using only once */
 int save_ln;


 char inbuf0[BUF_SIZE+1], /* input buffer 0 */
	inbuf1[BUF_SIZE+1],     /* input buffer 1 */
	*ncpnt,                 /* pointer to next character in input buffer*/
	*token_pnt;             /* pointer to 'token_buf' array */


/* AL ARRAY DECLARATIONS */

struct buf    {                 /* input buffer table format */
	       char     *start; /* pointer to start of input buffer */
	       char     *end;   /* pointer to end of input buffer */
	      };

 struct buf buffer[NUM_BUFFERS];


/* DEFINITIONS FOR WARNING MESSAGES */
/*   (must match positions in 'messages' array -- see error.c) */

#define EOF_ERR         0       /* unexpected end of file */
#define EOC_ERR         1       /* unexpected end of comment */
#define CHAR_ERR        2       /* illegal character in input ignored */
#define IDSIZ_ERR       3       /* identifier truncated to 6 characters */
#define TOKSIZ_ERR      4       /* token longer than 50 characters */


/* FUNCTION DECLARATIONS */

int     get_token(),            /* get a token */
	get_current_token(),    /* get the current token */
	getnextchar(),          /* get next character */
	char_type(),            /* determine character type */
	hex(),                  /* determine if character is hex */
	octal(),                /* determine if character is octal */
	compiler_keyword();     /* check if token is a compiler keyword */

void    fill_buf(),             /* routine for filling input buffer */
	putbackchar(),          /* routine for putting back character */
	assembler_keyword();    /* check if token is an assembler keyword */

#endif
