/* 910415  P1_STOP.C */

#include "stdarg.h"
#include "stdio.h"
#include "ctype.h"
#include "string.h"
#include "alloc.h"
#include "p1_common.h"
#include "p1_parser.h"
#include "p1_scanner.h"

/* ===========================================================================

   function name: stop
   input	       : ---
   output	    : ---
   return value : ret_value	- SUCCESS, if no error is detected
				                  - FAIL, otherwise, if an error occured

   global vars  : token_type 	- type of current token
		            token_buf	- current token string
		            symbol_table	- symbol table data structure
		            debug		- debugging statement flag

   description	 : This routine parses the stop statement.

			STOP_  <-- stop ;

=========================================================================== */

int stop_()
{
   int ret_value;		/* varaible for return value */


   if (debug == 2)
      printf ("In stop_().....................................\n");

   ret_value = SUCCESS;
   if (token_type != T_EOS)
     {ret_value = FAIL;
      print_msg (EOS_ERR, token_buf);}
   else
     {print_opcode ("stop", T_STOP, T_NONE, T_NONE);
      print_args (NULL, NULL, NULL, NULL, NULL);
      token_type = get_token();}

   if (debug == 2)
      printf ("stop_() returning ret_value : %d\n", ret_value);

   return(ret_value);

} /* end of stop_() */
